datablock AudioProfile(DragonfireSound)
{
   filename    = "./flame_thrower_loop.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(FireDartParticle)
{
	dragCoefficient		 = 1.5;
	gravityCoefficient	 = -0.25;
	inheritedVelFactor	 = 0.5;
	windCoefficient		 = 0.0;
	constantAcceleration = 0;
	lifetimeMS			= 700;	//900
	lifetimeVarianceMS	= 100;
	textureName			= "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]			= "1.0 0.4 0.0 0.2";
	colors[1]			= "1.0 0.2 0.0 0.35";
	colors[2]			= "0.7 0.0 0.0 0.0";
	sizes[0]			= 0.27;
	sizes[1]			= 0.34;
	sizes[2]			= 0.1;
	times[0]			= 0.0;
	times[1]			= 0.3;
	times[2]			= 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FireDartFireEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   ejectionOffset   = 0.05;
   thetaMin         = 0;
   thetaMax         = 15;
   phiReferenceVel  = 0;
   phiVariance      = 180;
   overrideAdvance = false;
   particles = "FireDartParticle";

   uiName = "Firedart Fire";
};

//datablock ParticleData(FireDartTrailParticle)
//{
//	dragCoefficient      = 2.5;
//	gravityCoefficient   = -0.17;
//	inheritedVelFactor   = 0.8;
//	constantAcceleration = 0;
//	lifetimeMS           = 850;
//	lifetimeVarianceMS   = 500;
//	textureName          = "base/data/particles/cloud";
//	spinSpeed		= 10.0;
//	spinRandomMin		= -500.0;
//	spinRandomMax		= 500.0;
//	colors[0]	= "0.1 0.1 1 1";
//	colors[1]	= "1 0.5 0 0.5";
//	colors[2]	= "1 0.25 0 0.25";
//	colors[3]	= "1 0 0 0";
//	sizes[0]	= 0.4;
//	sizes[1]	= 1.0;
//	sizes[2]	= 1.2;
//	sizes[3]	= 1.5;
//	times[0]	= 0;
//	times[1]	= 0.2;
//	times[2]	= 0.8;
//	times[3]	= 1;

//	useInvAlpha = false;
//};

datablock ParticleEmitterData(FireDartTrailEmitter)
{
   ejectionPeriodMS = 4;	//2
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 2;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FireDartParticle";

   uiName = "Firedart Flame";
};

datablock ParticleData(FireDartExplosionParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.7;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1300;
	lifetimeVarianceMS   = 900;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.2 0 0.4";
	colors[1]     = "1 0.1 0 0.3";
	colors[2]     = "1 0.1 0 0.0";
	sizes[0]      = 0.7;	//0.9
	sizes[1]      = 0.4;
	sizes[2]      = 0.1;
	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FireDartExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.02;
   thetaMin         = 0;
   thetaMax         = 65;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FireDartExplosionParticle";

   uiName = "Firedart Explosion";
};

datablock ExplosionData(FireDartExplosion)
{
   lifeTimeMS = 600;

   emitter[0] = FireDartexplosionEmitter;
	particleDensity = 25;
	particleRadius = 0.06;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

	damageRadius = 2.5;
	radiusDamage = 10;

	// Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 4;
   lightStartColor = "1 0.6 0";
   lightEndColor = "1 0.1 0";

   playerBurnTime = 3000;
};

datablock ProjectileData(DragonFireDartProjectile)
{
	shapeFile = "base/data/shapes/empty.dts";
   directDamage = 20;
   directDamageType = $DamageType::DragonFireDirect;
   radiusDamageType = $DamageType::DragonFireballRadius;

   brickExplosionRadius = 1;
   brickExplosionImpact = true;
   brickExplosionForce = 15;
   brickExplosionMaxVolume = 5;
   brickExplosionMaxVolumeFloating = 10;

//   impactImpulse = 300;
//   verticalImpulse = 200;
   explosion = FireDartExplosion;
   particleEmitter = FireDartTrailEmitter;
   sound = DragonfireSound;

   muzzleVelocity = 90;	//Fireball = 60
   velInheritFactor = 0;	//0

   armingDelay = 0;
   lifetime = 1500;			//4000
   fadeDelay = 1000;		//3500
   bounceElasticity = 0.5;
   bounceFriction = 0.20;
   isBallistic = true;
   gravityMod = 0.02;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1 0.4 0";
};

datablock ItemData(DragonFireDartItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./firedart_item.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "D - Firedart";
	iconName = "./Icon_Fire";
	doColorShift = true;
	colorShiftColor = "1 0.7 0 1";

	 // Dynamic properties defined by the scripts
	image = DragonFireDartImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DragonFireDartImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   //Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DragonFireDartprojectile;
   projectileType = Projectile;

   melee = false;
   armReady = false;

   doColorShift = false;
   colorShiftColor = DragonFireDartItem.colorShiftColor;

   //new energy usage thing
	energyUsage = 10;

   // Initial start up state
	stateName[0]					= "Initial";
	stateTimeoutValue[0]			= 0.1;
	stateTransitionOnTimeout[0]		= "Ready";
	//stateSound[0]					= weaponSwitchSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	
//	stateName[2]                    = "Charge";
//	stateAllowImageChange[2]        = true;
//	stateTransitionOnTimeout[2]     = "Fire";
//	stateTimeoutValue[2]            = 1.00;
//	stateWaitForTimeout[2]			= true;
//	stateTransitionOnTriggerUp[2]   = "Ready";
//	stateEmitter[2]					= FireDartambientEmitter;
//	stateEmitterTime[2]				= 1.00;
//	stateEmitterNode[2]				= "muzzlePoint";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Recharge";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]					= DragonfireSound;
	stateEmitter[2]					= FireDartFireEmitter;
	stateEmitterTime[2]				= 0.15;
	stateEmitterNode[2]				= "muzzlePoint";

	stateName[3]					= "Recharge";
	stateTransitionOnTimeout[3]		= "Ready";
	stateTimeoutValue[3]			= 0.55;
	stateAllowImageChange[3]		= true;
};
function DragonFireDartImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
		%obj.playThread(1, root);	//This is likely here to clear armready
									//animations
}
function DragonFireDartImage::onFire(%this,%obj,%slot)
{

	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);
		%obj.playThread(2, shiftAway);
		Parent::onFire(%this,%obj,%slot);
	}
}


